<template>
	<div class="auxiliary-business-tag-container layout-pd">
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
				<el-form-item label="关键字" prop="Keyword">
					<el-input v-model="state.queryParams.Keyword" placeholder="标签名称 " clearable @keyup.enter="queryList" class="keyword-input" />
				</el-form-item>
				<el-form-item label="标签类型" prop="Type">
					<el-select v-model="state.queryParams.Type" placeholder="请选择标签类型">
						<el-option v-for="item in tagType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item label="业务类型" prop="BusinessType">
					<el-select v-model="state.queryParams.BusinessType" placeholder="请选择业务类型">
						<el-option v-for="item in businessTagType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				:total="state.total"
				v-model:page-index="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
			>
				<!-- 表格 header 按钮 -->
				<template #tableHeader="scope">
					<el-button type="primary" @click="addParameter" v-auth="'auxiliary:businessTag:add'">
						<SvgIcon name="ele-Plus" class="mr5" />新增
					</el-button>
					<el-button type="primary" @click="businessTagRemove" v-auth="'auxiliary:businessTag:delete'" :disabled="!scope.isSelected">
						<SvgIcon name="ele-Delete" class="mr5" />删除
					</el-button>
					<el-button type="primary" @click="businessTagBinding" v-auth="'auxiliary:businessTag:binding'" :disabled="!scope.isSelected">
						<SvgIcon name="ele-Link" class="mr5" />批量绑定
					</el-button>
				</template>
				<!-- 表格操作 -->
				<template #operation="{ row }">
					<el-button link type="primary" @click="updateBusinessTag(row)" v-auth="'auxiliary:businessTag:edit'" title="修改业务标签"> 编辑 </el-button>
					<el-button link type="info" @click="viewBusinessTag(row)" title="查看详情"> 查看 </el-button>
				</template>
			</ProTable>
		</el-card>
		<!--  新增标签  -->
		<business-tag-add ref="businessTagAddRef" @updateList="queryList" :businessTagType="businessTagType" :tagType="tagType" />
		<!--  编辑标签  -->
		<business-tag-edit ref="businessTagEditRef" @updateList="queryList" :businessTagType="businessTagType" :tagType="tagType" />
		<!--  批量绑定  -->
		<business-tag-binding-com ref="businessTagBindingRef" @updateList="queryList" />
	</div>
</template>

<script lang="tsx" setup name="auxiliaryBusinessTag">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElButton, ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { businessTagBaseData, businessTagDelete, businessTagList } from '@/api/auxiliary/businessTag';
import dayjs from 'dayjs';
import { formatDate } from '@/utils/formatTime';
// 引入组件
const BusinessTagBindingCom = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-binding.vue')); // 绑定标签
const BusinessTagAdd = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-add.vue')); // 新增标签
const BusinessTagEdit = defineAsyncComponent(() => import('@/views/auxiliary/businessTag/components/Business-tag-edit.vue')); // 编辑标签

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'selection', fixed: 'left', width: 55 },
	{ prop: 'name', label: '标签名称' },
	{ prop: 'typeText', label: '标签类型', width: 130 },
	{ prop: 'businessTypeText', label: '业务类型', width: 300 },
	{ prop: 'classify', label: '分类名称' },
	{
		prop: 'creationTime',
		label: '创建时间',
		width: 170,
		render: (scope: any) => {
			return dayjs(scope.row.creationTime).format('YYYY-MM-DD HH:mm:ss');
		},
	},
	{ prop: 'creatorName', label: '创建人' },
	{ prop: 'creatorOrgName', label: '创建人部门' },
	{ prop: 'operation', label: '操作', fixed: 'right', width: 120, align: 'center' },
]);
// 定义变量内容
const state = reactive<any>({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 10,
		Keyword: null, // 参数名称
		Type: null, // 标签类型
		BusinessType: null, // 业务类型
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<any>(null); // 表单ref
const businessTagType = ref<EmptyArrayType>(); // 业务类型
const tagType = ref<EmptyArrayType>(); // 标签类型
// 获取基础数据
const getBaseData = async () => {
	try {
		const res = await businessTagBaseData();
		businessTagType.value = res.result?.businessTagType ?? [];
		tagType.value = res.result?.tagType ?? [];
	} catch (error) {
		console.log(error);
	}
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	businessTagList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
		})
		.finally(() => {
			state.loading = false;
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增标签
const businessTagAddRef = ref<RefType>(); // 新增标签
const addParameter = () => {
	businessTagAddRef.value.openDialog();
};
// 修改标签
const businessTagEditRef = ref<RefType>(); // 修改标签
const updateBusinessTag = (row: any) => {
	businessTagEditRef.value.openDialog(row.id);
};
// 查看详情
const viewBusinessTag = (row: any) => {
	businessTagEditRef.value.openDialog(row.id, true);
};
// 删除标签
const businessTagRemove = () => {
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	const names = proTableRef.value.selectedList.map((item: any) => item.name);
	ElMessageBox.confirm(`您确定要删除：【${names}】，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			businessTagDelete({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
// 批量绑定
const businessTagBindingRef = ref<RefType>(); // 绑定ref
const businessTagBinding = () => {
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	businessTagBindingRef.value.openDialog(ids);
};
// 页面加载时
onMounted(() => {
	getBaseData();
	queryList();
});
</script>
